import 'package:bird_cryptography/bird_cryptography.dart';
import 'package:bird_flutter/bird_flutter.dart';
import 'package:flutter/material.dart';
import 'package:neptune_cryptography_example/elements.dart';
import 'package:neptune_cryptography_example/widgets/simple_pw_digest_widget.dart';

class HMACSPage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return onListView() >> hmacs.map(simplePwDigestTile);
  }
}

const dart_hmacs = CryptographyHMACs.dart;

final List<AnnotatedValue<HMACCrypto>> hmacs = [
  AnnotatedValue("HMAC-md2", dart_hmacs.md2()),
  AnnotatedValue("HMAC-md4", dart_hmacs.md4()),
  AnnotatedValue("HMAC-md5", dart_hmacs.md5()),
  AnnotatedValue("HMAC-ripemd128", dart_hmacs.ripemd128()),
  AnnotatedValue("HMAC-ripemd160", dart_hmacs.ripemd160()),
  AnnotatedValue("HMAC-sha1", dart_hmacs.sha1()),
  AnnotatedValue("HMAC-sha224", dart_hmacs.sha224()),
  AnnotatedValue("HMAC-sha256", dart_hmacs.sha256()),
  AnnotatedValue("HMAC-sha384", dart_hmacs.sha384()),
  AnnotatedValue("HMAC-sha512", dart_hmacs.sha512()),
  AnnotatedValue("HMAC-tiger", dart_hmacs.tiger()),
];
