import 'package:bird_cryptography/bird_cryptography.dart';
import 'package:bird_flutter/bird_flutter.dart';
import 'package:flutter/material.dart';
import 'package:neptune_cryptography_example/elements.dart';
import 'package:neptune_cryptography_example/widgets/blocs.dart';

import 'input.dart';

Widget simplePwDigestTile(AnnotatedValue<SimplePWDigest> val) {
  return $$ >> (context) =>
      ListTile(
        title: Text(val.name),
        onTap: () => simplePwDigestDialog(context, val),
      );
}

void simplePwDigestDialog(BuildContext context,
    AnnotatedValue<SimplePWDigest> val) {
  showDialog<void>(
    context: context,
    builder: (_) =>
    $$ >> (context) {
      final bloc = $$$(() => CryptoSimplePWDigestBloc(val.value));
      return AlertDialog(
        title: Text(val.name),
        content: singleChildScrollView() > onColumnMinCenterCenter() >> [
          encodingWaved(
            just(false),
            bloc.sourceEncoding,
          ),
          signalInputWidget(
            signal: bloc.sourceText,
            label: just("Input"),
          ),

          verticalSpace(14.0),

          encodingWaved(
            just(false),
            bloc.pwEncoding,
          ),
          signalInputWidget(
            signal: bloc.pwText,
            label: just("PW"),
          ),

          verticalSpace(14.0),

          encodingWaved(
            bloc.isLoading.wave,
            bloc.targetEncoding,
          ),
          signalInputWidget(
            signal: bloc.targetText,
            label: just("Output"),
          ),
        ],
        actions: [
          loadingIndicator(bloc.isLoading.wave),
          calculate(bloc.isLoading.wave, bloc.convert) > const Text("Convert"),
          closeButton,
        ],
      );
    },
  );
}