import 'package:bird_cryptography/bird_cryptography.dart';

abstract class CryptographyHash extends SimpleDigest {
  const CryptographyHash();
}

abstract class CryptographyHashes {
  static const CryptographyHashes dart = PointycastleCryptographyHashes();

  static List<int> allowedSha512tDigestSizes() =>
      List.generate(63, (i) => i).map((f) => (f + 1)).toList()
        ..removeWhere((t) => t == 48);

  CryptographyHash keccak224();

  CryptographyHash keccak256();

  CryptographyHash keccak384();

  CryptographyHash keccak512();

  CryptographyHash md2();

  CryptographyHash md4();

  CryptographyHash md5();

  CryptographyHash ripemd128();

  CryptographyHash ripemd160();

  CryptographyHash ripemd256();

  CryptographyHash ripemd320();

  CryptographyHash sha1();

  CryptographyHash sha224();

  CryptographyHash sha256();

  CryptographyHash sha384();

  CryptographyHash sha512();

  CryptographyHash sha512t(int digestSize);

  CryptographyHash tiger();
}
